"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasDuplicated = exports.splitArrayAsNLength = void 0;
const deep_equal_1 = __importDefault(require("deep-equal"));
const splitArrayAsNLength = (vars, count) => {
    return vars.flatMap((_, index, array) => {
        return index % count !== 0 ? [] : [array.slice(index, index + count)];
    });
};
exports.splitArrayAsNLength = splitArrayAsNLength;
// Set() cannot detect not primitive value.
// ex: new Set([ [0, 1], [0, 1] ]) => Set(2) { [ 0, 1 ], [ 0, 1 ] }
const hasDuplicated = (values) => {
    for (let i = 0; i < values.length; i++) {
        // Check from next index.
        for (let j = i + 1; j < values.length; j++) {
            if ((0, deep_equal_1.default)(values[i], values[j]))
                return true;
        }
    }
    return false;
};
exports.hasDuplicated = hasDuplicated;
